package com.hzya.frame.sysnew.zxbank.service.impl;

import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.mdm.mdmModuleSource.dao.impl.MdmModuleSourceDaoImpl;
import com.hzya.frame.mdm.mdmModuleSource.entity.MdmModuleSourceEntity;
import com.hzya.frame.sysnew.comparison.service.impl.ComparisonServiceImpl;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.entity.IntegrationTaskLivingDetailsEntity;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.service.IIntegrationTaskLivingDetailsService;
import com.hzya.frame.sysnew.zxbank.dao.IZxBankDao;
import com.hzya.frame.sysnew.zxbank.entity.PayState;
import com.hzya.frame.sysnew.zxbank.entity.ZxBankEntity;
import com.hzya.frame.sysnew.zxbank.service.IZxBankService;
import com.hzya.frame.uuid.UUIDUtils;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

@Service("ZxBankServiceImpl")
public class ZxBankServiceImpl extends BaseService<ZxBankEntity, String> implements IZxBankService {

    @Autowired
    private MdmModuleSourceDaoImpl mdmModuleSourceDaoImpl;

   @Autowired
   private IZxBankDao zxBankDao;
    @Autowired
    private IIntegrationTaskLivingDetailsService taskLivingDetailsService;
    @Autowired
    private ComparisonServiceImpl comparisonServiceimpl;

    @Value("${zt.url}")
    private String url;
    @Override
    public JsonResultEntity queryArchives(JSONObject json) {
        JSONObject jsonObject = json.getJSONObject("jsonStr");
        //根据插件分类查询主数据来源表
        List<MdmModuleSourceEntity> list = mdmModuleSourceDaoImpl.MdmModuleSourceentityGroupByType();
        if (CollectionUtils.isEmpty(list)) {
            logger.info("没有类型为插件得数据,无法获取数据");
            return BaseResult.getFailureMessageEntity("数据来源表无插件类型");
        }
        for (MdmModuleSourceEntity mdmModuleSourceEntity : list) {
            String tableName = "";
            List<Object> object=new ArrayList<>();
            List<JSONObject> listAll  = new ArrayList<>();
            try {
                String appTyp = mdmModuleSourceEntity.getAppType();//系统类型  1、致远OA 2、用友U8C 3、用友BIP
                String dbCode = mdmModuleSourceEntity.getDbCode();//数据源编码
                String mdmCode = mdmModuleSourceEntity.getMdmCode();//主数据编码
                switch (appTyp){
                    case "1":
                        switch (mdmCode){
                            case ""://杭泰付款单
                                tableName = "mdm_zxbank";
                                listAll = bindingZxBank(jsonObject, mdmModuleSourceEntity, dbCode);
                                break;
                            default:
                                break;
                        }
                        break;
                    default:
                        break;
                }
                //将查询出来的数据进行组装，调用通用方法新增或者更新
                if (null != listAll && listAll.size() > 0) {
                    object = ParametricDocument(listAll, mdmCode, tableName);
                    if (CollectionUtils.isNotEmpty(object)) {
                        for (Object obj : object) {
                            //更新单据视图推送标识，不再抽取
                            JSONObject attributeResult = (JSONObject) JSON.toJSON(obj);
                            if (attributeResult.getString("status").equals("200")) {
                                String resultString = attributeResult.getString("list");
                                if ("".equals(mdmCode)) {
                                    JSONArray jsonArray = JSONArray.parseArray(resultString);
                                    if (CollectionUtils.isNotEmpty(jsonArray)) {
                                        for (Object o : jsonArray) {
                                            JSONObject attributeArray = (JSONObject) JSON.toJSON(o);
                                            String mdmZxBank = attributeArray.getString(tableName);
                                            JSONObject jsonObjectCmpApply = JSONObject.parseObject(mdmZxBank);
                                            String pushStatusField = jsonObjectCmpApply.getString("push_status_field");//推送标识字段
                                            String dataId = jsonObjectCmpApply.getString("data_id");//主表id
                                            String documentNo = jsonObjectCmpApply.getString("document_no");
                                            logger.info("=====开始根据单据id:{},单据号：{},更新杭泰表：{}的推送标识", dataId, documentNo, tableName);
                                            ZxBankEntity zxBankEntity = new ZxBankEntity();
                                            zxBankEntity.setTabName(jsonObjectCmpApply.getString("tab_name"));
                                            zxBankEntity.setPushStatusField(pushStatusField);
                                            zxBankEntity.setPushStatus("1");
                                            zxBankEntity.setId(dataId);
                                            zxBankEntity.setDataSourceCode(mdmModuleSourceEntity.getDataSourceCode());
                                            zxBankDao.updatePushStatus(zxBankEntity);
                                            //保存业务数据日志
                                            saveTaskLivingDetails(dataId, jsonObjectCmpApply.getString("document_no"), listAll.get(0).toString(), object.toString(), true,"ZxBankPluginInitializer");
                                        }
                                    }
                                }
                            } else {
                                saveTaskLivingDetails(JSONObject.parseObject(listAll.get(0).getString("mdm_zxbank")).getString("data_id"), JSONObject.parseObject(listAll.get(0).getString("mdm_zxbank")).getString("document_no"), listAll.get(0).toString(), JSON.parseObject(JSON.toJSONString(object)).getString("msg"), false,"ZxBankPluginInitializer");
                            }
                        }
                    }
                } else {
                    logger.info("三维单据视图数据没有需要同步中台的数据");
                }
            }catch (Exception e){
                logger.info("杭泰付款单同步失败:{}",e.getMessage());
                saveTaskLivingDetails(JSONObject.parseObject(listAll.get(0).getString("mdm_zxbank")).getString("data_id"),JSONObject.parseObject(listAll.get(0).getString("mdm_zxbank")).getString("document_no"),listAll.get(0).toString(),JSON.parseObject(JSON.toJSONString(object)).getString("msg")==null?JSON.parseObject(JSON.toJSONString(object)).getString("list"):JSON.parseObject(JSON.toJSONString(object)).getString("msg"),false,"ZxBankPluginInitializer");
                e.printStackTrace();
            }
        }
        return BaseResult.getSuccessMessageEntity("业务数据同步成功");
    }

    @Override
    public JsonResultEntity queryArchivesResult(JSONObject json) {
        try {
            JSONObject jsonObject = json.getJSONObject("jsonStr");
            ZxBankEntity zxBankEntity = jsonObject.toJavaObject(ZxBankEntity.class);
            zxBankEntity.setDataSourceCode("");
            logger.info("======开始查询中信返回的支付结果=====");
            List<ZxBankEntity> zxBankEntities = zxBankDao.queryResultIsNull(zxBankEntity);
            if(CollectionUtils.isEmpty(zxBankEntities)){
                logger.info("=====杭泰付款单中没有已推送并且支付结果为空的数据========");
                return BaseResult.getSuccessMessageEntity("查询成功");
            }
            for (ZxBankEntity bankEntity : zxBankEntities) {
                List<String> list = new ArrayList<>();
                list.add(bankEntity.getDocumentNo());
                String params = String.join(", ", list);
                logger.info("=======杭泰付款单调用中信支付结果查询请求参数为:{}", params);
                //发送数据
                String result = HttpRequest.post(url).
                        header("appId", "").
                        header("apiCode", "").
                        //header("access_token", tokenBody).
                                header("publicKey", "ZJYAQ/VtQ66PqKXlV0EowrrlKkhBHYgS/Zk39Q5ezIQne51Ce7eDIk+3zDUT+v578prj").
                        header("secretKey", "iLLk424Bmzknbu+ROeJoiVDMYY5EFXtbZY/aU13HmVYIiQrIw9c0Ag4ipxbfpUqqj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=").
                        body(params).
                        execute().
                        body();
                logger.info("========杭泰付款单调用中信支付结果查询返回参数为:{}==========", result);
                JSONObject resultJson = JSONObject.parseObject(result);
                if (!resultJson.getBoolean("flag")) {
                    saveTaskLivingDetails(bankEntity.getDataId(), bankEntity.getDocumentNo(), params, resultJson.toJSONString(), false,"ZxBankResultPluginInitializer");
                } else {
                    String data = resultJson.getString("data");
                    JSONObject jsonObjectData = JSONObject.parseObject(data);
                    JSONArray jsonArray = jsonObjectData.getJSONArray("list");
                    if(CollectionUtils.isNotEmpty(jsonArray)){
                        for (Object o : jsonArray) {
                            JSONObject jsonObjectList=(JSONObject) JSON.toJSON(o);
                            String documentNo = jsonObjectList.getString("documentNo");//返回的业务单据号
                            String payStatus = jsonObjectList.getString("payStatus");//返回的状态
                            String errorMsg = jsonObjectList.getString("errorMsg");//返回的错误信息
                            logger.info("====付款單查询中信返回的单据号为：{}，返回结果为：{}，错误信息为：{}",documentNo,payStatus,errorMsg);
                            if(documentNo.equals(bankEntity.getDocumentNo())){
                                //修改支付状态
                                bankEntity.setPayResult(PayState.payStateGetValue(payStatus));
                                zxBankDao.updateResultStatus(bankEntity);
                                saveTaskLivingDetails(bankEntity.getDataId(), bankEntity.getDocumentNo(), params, resultJson.toJSONString(), true,"ZxBankResultPluginInitializer");
                            }
                        }
                    }else{
                        logger.info("====查询支付结果返回值中的list为空====");
                    }
                }
            }
            logger.info("========杭泰付款单查询支付结果执行成功========");
            return BaseResult.getSuccessMessageEntity("支付结果查询成功");
        }catch (Exception e){
            logger.info("=========查询中信返回的支付结果失败=======",e.getMessage());
            e.printStackTrace();
        }
        return BaseResult.getFailureMessageEntity("支付结果查询失败");
    }

    @Override
    public JsonResultEntity queryArchivesElec(JSONObject json) {
        try {
            JSONObject jsonObject = json.getJSONObject("jsonStr");
            ZxBankEntity zxBankEntity = jsonObject.toJavaObject(ZxBankEntity.class);
            zxBankEntity.setDataSourceCode("");
            logger.info("======开始查询中信电子回单=====");
            List<ZxBankEntity> zxBankEntities = zxBankDao.queryElecIsNull(zxBankEntity);
            if(CollectionUtils.isEmpty(zxBankEntities)){
                logger.info("=====杭泰付款单中没有已支付并且电子回单为空的数据========");
                return BaseResult.getSuccessMessageEntity("查询成功");
            }
            for (ZxBankEntity bankEntity : zxBankEntities) {
                JSONObject jsonParam=new JSONObject();
                jsonParam.put("companyCode",bankEntity.getCompanyCode());//公司编码
                jsonParam.put("documentNo",bankEntity.getDocumentNo());//单据号
                String params = jsonParam.toJSONString();
                logger.info("======杭泰付款单调用中信电子回单查询请求参数为:{}========",params);
                //发送数据
                String result = HttpRequest.post(url).
                        header("appId", "").
                        header("apiCode", "").
                        //header("access_token", tokenBody).
                                header("publicKey", "ZJYAQ/VtQ66PqKXlV0EowrrlKkhBHYgS/Zk39Q5ezIQne51Ce7eDIk+3zDUT+v578prj").
                        header("secretKey", "iLLk424Bmzknbu+ROeJoiVDMYY5EFXtbZY/aU13HmVYIiQrIw9c0Ag4ipxbfpUqqj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=").
                        body(params).
                        execute().
                        body();
                logger.info("======杭泰付款单调用中信电子回单查询返回参数为:{}========",result);
                JSONObject resultJson = JSONObject.parseObject(result);
                if (!resultJson.getBoolean("flag")) {
                    saveTaskLivingDetails(bankEntity.getDataId(), bankEntity.getDocumentNo(), params, resultJson.toJSONString(), false,"ZxBankElecPluginInitializer");
                } else {
                    String data = resultJson.getString("data");
                    JSONObject jsonObjectData = JSONObject.parseObject(data);
                    String billId = jsonObjectData.getString("billId");  //电子回单id  电子回单下载需要
                    logger.info("======中信电子回单返回的电子回单id为:{}====",billId);
                    if(StrUtil.isNotEmpty(billId)){
                        List<String> list=new ArrayList<>();
                        list.add(billId);
                        String paramList = String.join(", ", list);
                        logger.info("====调用中信电子回单下载得请求参数为：{}=======",paramList);
                        elecDownlod(paramList);
                    }
                }
            }
        }catch (Exception e){
            logger.info("======杭泰付款单查询中信电子回单失败:{}",e.getMessage());
            e.printStackTrace();
        }
        return null;
    }

    private JsonResultEntity elecDownlod(String params){
        try {
            //发送数据
            String result = HttpRequest.post(url).
                    header("appId", "").
                    header("apiCode", "").
                    //header("access_token", tokenBody).
                            header("publicKey", "ZJYAQ/VtQ66PqKXlV0EowrrlKkhBHYgS/Zk39Q5ezIQne51Ce7eDIk+3zDUT+v578prj").
                    header("secretKey", "iLLk424Bmzknbu+ROeJoiVDMYY5EFXtbZY/aU13HmVYIiQrIw9c0Ag4ipxbfpUqqj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=").
                    body(params).
                    execute().
                    body();
            logger.info("======杭泰付款单调用中信电子回单下载返回参数为:{}========",result);
        }catch (Exception e){
            logger.info("=======中信电子回单下载失败：{}======",e.getMessage());
            e.printStackTrace();
        }
        return null;
    }


    private List<JSONObject> bindingZxBank(JSONObject jsonObject, MdmModuleSourceEntity mdmModuleSourceEntity, String dbCode) {
        List<JSONObject> list = new ArrayList<>();
            StringBuffer stringBuffer = new StringBuffer();
            stringBuffer.append("select * from v_hzya_pay where 1=1 and  pushStatus is null ");
            mdmModuleSourceEntity.setDataSourceCode(dbCode);
            List<HashMap<String, Object>> hashMaps = zxBankDao.queryListByBank(stringBuffer.toString(), mdmModuleSourceEntity);
            int i = 0;
            if (CollectionUtils.isNotEmpty(hashMaps)) {
                for (HashMap<String, Object> hashMap : hashMaps) {
                    JSONObject main = new JSONObject();
                    JSONObject bank = new JSONObject();
                    for (String key : hashMap.keySet()) {
                        bank.put(key.toLowerCase(), hashMap.get(key));
                    }
                    main.put("mdm_zxbank", bank);
                    list.add(main);
                }
            }
            return list;
    }


    private List<Object> ParametricDocument(List<JSONObject>  hashMaps,String mdmCode,String tableName){
        JSONObject jsonObjectUser = new JSONObject();
        List<Object> result=new ArrayList<>();
        try {
            for (JSONObject hashMap : hashMaps) {
                JSONObject main = hashMap.getJSONObject(tableName);
                JSONObject jsonStr = new JSONObject();
                jsonObjectUser.put("data_id", main.get("data_id"));
                jsonObjectUser.put("mdmCode", mdmCode);
                jsonStr.put("jsonStr", jsonObjectUser);
                //先查询编码和名称查询是否存在
                Object attribute = comparisonServiceimpl.queryEntityPage(jsonStr);
                logger.info("得到的attribute值为：{}", jsonStr.toJSONString(attribute));
                JSONObject jsonObjectAttribute = (JSONObject) JSON.toJSON(attribute);
                JSONObject pageInfo = jsonObjectAttribute.getJSONObject("pageInfo");
                JSONArray jsonArrayList = pageInfo.getJSONArray("list");
                //如果jsonArrayList为null，说明没有值，在表中不存在
                if (jsonArrayList == null || jsonArrayList.size() == 0) {
                    hashMap.put("appName","数智中台");
                    hashMap.put("appCode","800004");
                    hashMap.put("mdmCode", mdmCode);
                    hashMap.put("optionName", "数智中台");
                    jsonStr.put("jsonStr", hashMap);
                    Object  object = comparisonServiceimpl.saveEntity(jsonStr);
                    logger.info("应付单新增结果为：{}", JSON.toJSONString(object));
                    result.add(object);
                } else {
                    hashMap.put("appName","数智中台");
                    hashMap.put("appCode","800004");
                    hashMap.put("mdmCode", mdmCode);
                    hashMap.put("optionName", "数智中台");
                    jsonStr.put("jsonStr", hashMap);
                    Object object = comparisonServiceimpl.updateEntity(jsonStr);
                    logger.info("应付单更新结果为：{}", JSON.toJSONString(result));
                    result.add(object);
                }
            }
            return result;
        }catch (Exception e){
            logger.info("将数据查询之后进行组装调用通用方法错误:{}",e.getMessage());
            //保存业务数据日志
            saveTaskLivingDetails(jsonObjectUser.getString("data_id"),hashMaps.get(0).getString("documentNo"),hashMaps.get(0).toString(),result.toString(),false,"ZxBankPluginInitializer");
            e.printStackTrace();
        }
        return null;
    }

    private void saveTaskLivingDetails(String rootAppPk,String rootAppBill,String rootAppNewData,String newTransmitInfo,boolean flag,String plugin) {
        try {
            IntegrationTaskLivingDetailsEntity integrationTaskLivingDetailsEntity = new IntegrationTaskLivingDetailsEntity();
            integrationTaskLivingDetailsEntity.setId(UUIDUtils.getUUID());
            integrationTaskLivingDetailsEntity.setSts("Y");
            integrationTaskLivingDetailsEntity.setCreate_user_id("1");
            integrationTaskLivingDetailsEntity.setModify_user_id("1");
            integrationTaskLivingDetailsEntity.setCreate_time(new Date());
            integrationTaskLivingDetailsEntity.setModify_time(new Date());
            integrationTaskLivingDetailsEntity.setOrg_id("0");
            integrationTaskLivingDetailsEntity.setCompanyId("0");
            integrationTaskLivingDetailsEntity.setRootAppPk(rootAppPk);
            integrationTaskLivingDetailsEntity.setRootAppBill(rootAppBill);
            integrationTaskLivingDetailsEntity.setPluginId(plugin);
            integrationTaskLivingDetailsEntity.setRootAppNewData(rootAppNewData);
            integrationTaskLivingDetailsEntity.setNewTransmitInfo(newTransmitInfo);
            if(flag){
                taskLivingDetailsService.saveLogToSuccess(integrationTaskLivingDetailsEntity);
            }else {
                taskLivingDetailsService.saveLogToFail(integrationTaskLivingDetailsEntity);
            }
        }catch (Exception e){
            logger.info("抽取杭泰付款单保存日志到集成任务日志明细中失败:{}",e.getMessage());
            e.printStackTrace();
        }
    }

}
